<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row q-gutter-x-sm">
      <div class="col-md-12">
        <q-card class="q-px-sm ">
          <q-card-section class="q-py-none ">
            <h6 class="q-my-sm q-pt-md">รายงานผลประกอบการ</h6>
          </q-card-section>
          <q-card-section>
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 40px; min-width: 80px;"
              >
                ประเภทเกม
              </div>
              <div class="col">
                <q-checkbox
                  v-model="game_type"
                  :key="item.code"
                  v-for="item in groupList"
                  :val="item.code"
                  :label="item.code"
                />
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <div class="row q-gutter-x-sm">
              <div
                class="col-auto text-right"
                style="line-height: 50px; min-width: 80px;"
              >
                ผู้ให้บริการ
              </div>
              <div class="col">
                <q-checkbox
                  checked
                  v-model="provider_code"
                  :key="item.code"
                  v-for="item in providerList"
                  :val="item.code"
                  :label="item.name"
                />
                <!-- <q-select
                  outlined
                  dense
                  v-model="provider_code"
                  multiple
                  :options="providerList"
                  option-value="code"
                  option-label="name"
                  emit-value
                  style="min-width: 250px; "
                >
                  <template v-if="provider_code.length > 0" v-slot:append>
                    <q-icon
                      name="cancel"
                      @click.stop="provider_code = []"
                      class="cursor-pointer"
                    />
                  </template>
                </q-select> -->
              </div>
            </div>
          </q-card-section>
          <q-card-section class="q-py-none">
            <StartDateEndDateFilterComponent :filter="dateFilter" />
          </q-card-section>
          <q-card-section class="q-py-sm">
            <q-btn color="green" @click.prevent="onSearch" icon="search"
              >ค้นหา</q-btn
            >
          </q-card-section>

          <!-- v-if="data" -->

          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :pagination.sync="pagination"
            :loading="loading"
            :data="[{}]"
            separator="cell"
            row-key="id"
            @request="onRequest"
          >
            <template slot="header" slot-scope="props" :props="props">
              <q-tr>
                <q-th rowspan="2" class="bg-blue-9 text-white">
                  ยูสเซอร์เนม
                </q-th>

                <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
                <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
                <q-th
                  v-if="role <= 5"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 4 >= role ? "ซีเนียร์" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 4"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 3 >= role ? "ผู้ถือหุ่น" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 3"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 2 >= role ? "คอมปะนี" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 2"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 1 >= role ? "Smart Bet" : "คอมปะนี" }}
                </q-th>
                <q-th
                  v-if="role <= 1"
                  colspan="1"
                  class="bg-blue-10 text-white"
                >
                  {{ 0 >= role ? "Provider" : "คอมปะนี" }}
                </q-th>
              </q-tr>
              <q-tr>
                <q-th
                  class="bg-light-blue-5 text-white"
                  v-for="index in role < 2 ? 7 : 6 - role + 2"
                  :key="index"
                  >W/L
                </q-th>
              </q-tr>
            </template>
            <template slot="body" slot-scope="props" :props="props">
              <template v-if="data && !isArray">
                <tr>
                  <td class="flex justify-center text-center">
                    <div
                      class="cursor-pointer  "
                      @click="isClick ? handleClickUserName(data) : null"
                      style="justify-content: center;align-items: center;display: flex;"
                    >
                      {{ data.username }}
                    </div>
                    <q-btn
                      @click="handleClickCopy(data.username)"
                      flat
                      round
                      icon="content_copy"
                    />
                  </td>
                  <td class="text-center" :class="bgFunc(getWinLose(6))">
                    {{ getWinLose(6) }}
                  </td>
                  <td class="text-center" :class="bgFunc(getWinLose(5))">
                    {{ getWinLose(5) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 5"
                    :class="bgFunc(getWinLose(4))"
                  >
                    {{ getWinLose(4) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 4"
                    :class="bgFunc(getWinLose(3))"
                  >
                    {{ getWinLose(3) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 3"
                    :class="bgFunc(getWinLose(2))"
                  >
                    {{ getWinLose(2) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 2"
                    :class="bgFunc(getWinLose(1))"
                  >
                    {{ getWinLose(1) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 1"
                    :class="bgFunc(getWinLose(0))"
                  >
                    {{ getWinLose(0) }}
                  </td>
                </tr>
              </template>

              <template v-else-if="isArray">
                <tr v-for="(item, index) in data" :key="index">
                  <td class="flex justify-center text-center">
                    <div
                      class="cursor-pointer"
                      @click="isClick ? handleClickUserName(item) : null"
                      style="justify-content: center;align-items: center;display: flex;"
                    >
                      {{ item.username }}
                    </div>
                    <q-btn
                      @click="handleClickCopy(item.username)"
                      flat
                      round
                      icon="content_copy"
                    />
                  </td>

                  <td
                    class="text-center"
                    :class="bgFunc(getWinLose(6, item.reports))"
                  >
                    {{ getWinLose(6, item.reports) }}
                  </td>
                  <td
                    class="text-center"
                    :class="bgFunc(getWinLose(5, item.reports))"
                  >
                    {{ getWinLose(5, item.reports) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 5"
                    :class="bgFunc(getWinLose(4, item.reports))"
                  >
                    {{ getWinLose(4, item.reports) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 4"
                    :class="bgFunc(getWinLose(3, item.reports))"
                  >
                    {{ getWinLose(3, item.reports) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 3"
                    :class="bgFunc(getWinLose(2, item.reports))"
                  >
                    {{ getWinLose(2, item.reports) }}
                  </td>
                  <td
                    class="text-center"
                    v-if="role <= 2"
                    :class="bgFunc(getWinLose(1, item.reports))"
                  >
                    {{ getWinLose(1, item.reports) }}
                  </td>
                  <!-- <td
                    class="text-center"
                    v-if="role <= 1"
                    :class="bgFunc(getWinLose(0, item.reports))"
                  >
                    {{ getWinLose(0, item.reports) }}
                  </td> -->
                  <td v-if="role <= 1" class="text-center">
                    0.00
                  </td>
                </tr>
              </template>

              <tr v-else>
                <td>
                  No data available
                </td>
              </tr>
            </template>
            <template v-slot:loading>
              <q-inner-loading showing color="primary" />
            </template>
          </q-table>
        </q-card>
      </div>
    </div>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions, mapMutations } from "vuex";
import { SessionStorage, LocalStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";
import { copyToClipboard } from "quasar";

const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");
export default {
  name: "Index",
  components: {
    StartDateEndDateFilterComponent
  },
  props: {
    isClick: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      data: null,
      loading: false,
      dateFilter: {
        startDate:
          new Date().getDate() !== 1
            ? new Date().setDate(1)
            : new Date(
                new Date().getFullYear(),
                new Date().getMonth() - 1
              ).setDate(1),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date().setDate(new Date().getDate() - 1),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      filter: {
        username: undefined,
        parent_id: undefined,
        level: undefined
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 25,
        rowsNumber: 0
      },
      groupList: [],
      providerList: [],
      isArray: false
    };
  },

  async created() {
    document.title = "Report";
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
      this.game_type = this.groupList
        .filter(
          (item, index) =>
            this.groupList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    } else {
      try {
        const {
          data: { results }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
      this.provider_code = this.providerList
        .filter(
          (item, index) =>
            this.providerList.findIndex(r => r.code == item.code) == index
        )
        .map(x => x.code);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
          this.provider_code = this.providerList
            .filter(
              (item, index) =>
                this.providerList.findIndex(r => r.code == item.code) == index
            )
            .map(x => x.code);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    await this.onSearch();
  },

  computed: {
    ...mapState("auth", ["role"]),
    ...mapGetters("report/v2", {
      datetime: "getDateTime"
    }),

    numberFormat() {
      return (number, digit = 2, comma = true) =>
        new Intl.NumberFormat("en-US", {
          minimumFractionDigits: digit,
          maximumFractionDigits: digit,
          useGrouping: comma
        }).format(number);
    },
    convertToFloat() {
      return number => parseFloat(this.numberFormat(number, 2, false));
    },
    bgFunc() {
      return inValue => {
        const value = this.convertToFloat(inValue.replace(/,/g, ""));

        if (value > 0) {
          return "text-green-8 text-bold";
        }
        if (value == 0) {
          return "";
        }
        return "text-red-10 text-bold";
      };
    }
  },

  methods: {
    ...mapActions("report/v2", ["getAllReport", "getOrganizationById"]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    ...mapMutations("report/v2", ["setDateTime", "setGameType", "setProvider"]),

    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
    },
    getFilterParameter({ filter = this.filter, pagination = this.pagination }) {
      if (this.$route.meta.level) {
        filter.level = this.$route.meta.level;
      }
      if (this.$route.params.id) {
        filter.parent_id = this.$route.params.id;
      } else {
        delete filter.parent_id;
      }
      let start = undefined;
      let end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }
      return {
        // ...filter,
        // ...pagination,
        page: pagination.page,
        limit: pagination.rowsPerPage,
        typeCode: this.game_type.join(",")
          ? this.game_type.join(",")
          : undefined,
        providerCode: this.provider_code.join(",")
          ? this.provider_code.join(",")
          : undefined,
        start: new Date(start).toISOString(),
        end: new Date(end).toISOString()
      };
    },
    async onRequest(props) {
      try {
        this.loading = true;
        const parameters = this.getFilterParameter(props);

        const { data } = await this.getAllReport({
          ...parameters
        });

        this.isArray = Array.isArray(data.results);

        // if (this.isArray) {
        //   await Promise.all(
        //     data.results.map(async x => {
        //       const data = await this.$services.company.find_by_id(x.code);

        //       x.data = JSON.parse(JSON.stringify(data));
        //     })
        //   );
        // }
        this.data = data.results;
      } catch (ex) {
        this.$dialog.errorException(ex);

        // this.$q.loading.hide();
      }
      this.loading = false;
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },

    getWinLose(level, targetdata) {
      let report = !targetdata ? [...this.data.report] : [...targetdata];
      let wl = 0;
      if (report.length === 0) return this.numberWithCommas(wl.toFixed(2));

      if ((this.role == 0 || this.role == 1) && level < 2) {
        let b = report.filter(x => x.level !== 6);
        let a = report.find(x => x.level === 6);
        let sum = 0;
        b.map(x => {
          sum += x.winLoss;
        });
        wl = a.winLoss - sum;
      } else if (level >= this.role) {
        const targetReport = report.find(x => x.level === level);
        if (targetReport) {
          wl = targetReport.winLoss;
          if (level == 6) {
            wl = wl * -1;
          }
        }
      } else {
        report = report.filter(x => x.level > level);

        wl = report.reverse().reduce((a, b) => a.winLoss - b.winLoss);
      }

      return this.numberWithCommas(wl.toFixed(2));
    },
    numberWithCommas(x) {
      var parts = x.toString().split(".");
      parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      return parts.join(".");
    },

    handleClickUserName(userData) {
      this.setDataToSession();

      this.setDateTime(this.dateFilter);
      this.setGameType(this.game_type);
      this.setProvider(this.provider_code);

      this.$router.push(`${this.$route.path}/${userData.accountId}`);
    },

    async setDataToSession() {
      var obj = {};

      obj[this.$route.fullPath] = this.data;
      // await SessionStorage.set("report_data", JSON.stringify(obj));
      await SessionStorage.set("from_path", [this.$route.fullPath]);
    },

    checkCurrentData() {
      // var obj = {};
      // obj = JSON.parse(SessionStorage.getItem("report_data") || "{}");
      // if (obj[this.$route.fullPath]) {
      //   this.isFavorite = obj[this.$route.fullPath];
      // }
    },
    handleClickCopy(text) {
      copyToClipboard(text)
        .then(() => {
          // success!

          this.$q.notify({
            message: "text has been copy"
          });
        })
        .catch(() => {
          // fail
        });
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
